/* $Id: db_firebird.h,v 1.2 2005/10/29 13:57:41 zglozik Exp $ */
/* ====================================================================
 * Copyright (c) 2004 Clizio Merli.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the OpenTSA Project.
 *    (http://www.opentsa.org/)"
 *
 * 4. The name "OpenTSA" must not be used to endorse or promote products
 *    derived from this software without prior written permission.
 *    For written permission, please contact zglozik@stones.com.
 *
 * 5. Products derived from this software may not be called "OpenTSA"
 *    nor may "OpenTSA" appear in their names without prior written
 *    permission of the OpenTSA Project.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the OpenTSA Project.
 *    (http://www.opentsa.org/)"
 *
 * THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE OpenTSA PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This product includes software developed by the OpenSSL Project
 * for use in the OpenSSL Toolkit (http://www.OpenSSL.org/).
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).
 * This product includes software written by Tim Hudson (tjh@cryptsoft.com).
 */

#ifndef __DB_FIREBIRD_H__
#define __DB_FIREBIRD_H__

#include "db.h"
#include <http_config.h>

/* Configuration-related declarations. */
struct DB_firebird_conf_st;
typedef struct DB_firebird_conf_st DB_firebird_conf;

extern DB_firebird_conf *db_firebird_create_config(apr_pool_t *p);

extern const char *db_firebird_set_host(cmd_parms *cmd, void *mconfig, 
					const char *host);

extern const char *db_firebird_set_port(cmd_parms *cmd, void *mconfig, 
					const char *port);

extern const char *db_firebird_set_unix_socket(cmd_parms *cmd, void *mconfig,
					       const char *socket);

extern const char *db_firebird_set_user(cmd_parms *cmd, void *mconfig, 
					const char *user);

extern const char *db_firebird_set_database(cmd_parms *cmd, void *mconfig,
					    const char *database);

extern const char *db_firebird_set_passphrase(cmd_parms *cmd, void *mconfig,
					      int passphrase);

/* Global FireBird method table. */
extern DB_methods       db_firebird_methods;

#endif  /* __DB_FIREBIRD_H__ */
